ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
Revision: 2.46
Committed: Mon Apr 7 21:33:25 2014 UTC (10 years ago) by greg
Content type: text/plain
Branch: MAIN
Changes since 2.45: +3 -3 lines
Log Message:
Added protection against very small dimension(s)

File Contents

# Content
1 #!/usr/bin/perl -w
2 # RCSid $Id: genBSDF.pl,v 2.45 2013/10/03 17:27:41 greg Exp $
3 #
4 # Compute BSDF based on geometry and material description
5 #
6 # G. Ward
7 #
8 use strict;
9 use File::Temp qw/ :mktemp /;
10 sub userror {
11 print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12 exit 1;
13 }
14 my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
15 chomp $td;
16 my @savedARGV = @ARGV;
17 my $tensortree = 0;
18 my $ttlog2 = 4;
19 my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
21 my $mgfin = 0;
22 my $geout = 1;
23 my $nproc = 1;
24 my $doforw = 0;
25 my $doback = 1;
26 my $pctcull = 90;
27 my $gunit = "meter";
28 my @dim;
29 # Get options
30 while ($#ARGV >= 0) {
31 if ("$ARGV[0]" =~ /^[-+]m/) {
32 $mgfin = ("$ARGV[0]" =~ /^\+/);
33 } elsif ("$ARGV[0]" eq "-r") {
34 $rtargs = "$rtargs $ARGV[1]";
35 shift @ARGV;
36 } elsif ("$ARGV[0]" =~ /^[-+]g/) {
37 $geout = ("$ARGV[0]" =~ /^\+/);
38 $gunit = $ARGV[1];
39 if ($gunit !~ /^(?i)(meter|foot|inch|centimeter|millimeter)$/) {
40 die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
41 }
42 shift @ARGV;
43 } elsif ("$ARGV[0]" =~ /^[-+]f/) {
44 $doforw = ("$ARGV[0]" =~ /^\+/);
45 } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46 $doback = ("$ARGV[0]" =~ /^\+/);
47 } elsif ("$ARGV[0]" eq "-t") {
48 # Use value < 0 for rttree_reduce bypass
49 $pctcull = $ARGV[1];
50 shift @ARGV;
51 } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52 $tensortree = substr($ARGV[0], 2, 1);
53 $ttlog2 = $ARGV[1];
54 shift @ARGV;
55 } elsif ("$ARGV[0]" eq "-c") {
56 $nsamp = $ARGV[1];
57 shift @ARGV;
58 } elsif ("$ARGV[0]" eq "-n") {
59 $nproc = $ARGV[1];
60 shift @ARGV;
61 } elsif ("$ARGV[0]" =~ /^-d/) {
62 userror() if ($#ARGV < 6);
63 @dim = @ARGV[1..6];
64 shift @ARGV for (1..6);
65 } elsif ("$ARGV[0]" =~ /^[-+]./) {
66 userror();
67 } else {
68 last;
69 }
70 shift @ARGV;
71 }
72 # Check that we're actually being asked to do something
73 die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
74 # Get scene description and dimensions
75 my $radscn = "$td/device.rad";
76 my $mgfscn = "$td/device.mgf";
77 my $octree = "$td/device.oct";
78 if ( $mgfin ) {
79 system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
80 die "Could not load MGF input\n" if ( $? );
81 system "mgf2rad $mgfscn > $radscn";
82 } else {
83 system "xform -e @ARGV > $radscn";
84 die "Could not load Radiance input\n" if ( $? );
85 system "rad2mgf $radscn > $mgfscn" if ( $geout );
86 }
87 if ($#dim != 5) {
88 @dim = split ' ', `getbbox -h $radscn`;
89 }
90 print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
91 # Add receiver surfaces (rectangular)
92 my $fmodnm="receiver_face";
93 my $bmodnm="receiver_behind";
94 open(RADSCN, ">> $radscn");
95 print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
96 print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
97 print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
98 print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
99 close RADSCN;
100 # Generate octree
101 system "oconv -w $radscn > $octree";
102 die "Could not compile scene\n" if ( $? );
103 # Output XML prologue
104 print
105 '<?xml version="1.0" encoding="UTF-8"?>
106 <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
107 ';
108 print "<!-- File produced by: genBSDF @savedARGV -->\n";
109 print
110 '<WindowElementType>System</WindowElementType>
111 <FileType>BSDF</FileType>
112 <Optical>
113 <Layer>
114 <Material>
115 <Name>Name</Name>
116 <Manufacturer>Manufacturer</Manufacturer>
117 ';
118 printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
119 printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
120 printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
121 print "\t\t<DeviceType>Other</DeviceType>\n";
122 print " </Material>\n";
123 # Output MGF description if requested
124 if ( $geout ) {
125 print "\t<Geometry format=\"MGF\">\n";
126 print "\t\t<MGFblock unit=\"$gunit\">\n";
127 printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
128 open(MGFSCN, "< $mgfscn");
129 while (<MGFSCN>) { print $_; }
130 close MGFSCN;
131 print "xf\n";
132 print "</MGFblock>\n";
133 print "\t</Geometry>\n";
134 }
135 # Set up surface sampling
136 my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
137 my $ny = int($nsamp/$nx + 1);
138 $nsamp = $nx * $ny;
139 my $ns = 2**$ttlog2;
140 my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
141 # Create data segments (all the work happens here)
142 if ( $tensortree ) {
143 do_tree_bsdf();
144 } else {
145 do_matrix_bsdf();
146 }
147 # Output XML epilogue
148 print
149 '</Layer>
150 </Optical>
151 </WindowElement>
152 ';
153 # Clean up temporary files and exit
154 exec("rm -rf $td");
155
156 #-------------- End of main program segment --------------#
157
158 #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
159 sub do_tree_bsdf {
160 # Shirley-Chiu mapping from unit square to disk
161 $sq2disk = '
162 in_square_a = 2*in_square_x - 1;
163 in_square_b = 2*in_square_y - 1;
164 in_square_rgn = if(in_square_a + in_square_b,
165 if(in_square_a - in_square_b, 1, 2),
166 if(in_square_b - in_square_a, 3, 4));
167 out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
168 -in_square_a, -in_square_b);
169 out_disk_phi = PI/4 * select(in_square_rgn,
170 in_square_b/in_square_a,
171 2 - in_square_a/in_square_b,
172 4 + in_square_b/in_square_a,
173 if(in_square_b*in_square_b,
174 6 - in_square_a/in_square_b, 0));
175 Dx = out_disk_r*cos(out_disk_phi);
176 Dy = out_disk_r*sin(out_disk_phi);
177 Dz = sqrt(1 - out_disk_r*out_disk_r);
178 ';
179 # Shirley-Chiu mapping from unit disk to square
180 $disk2sq = '
181 norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
182 in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
183 in_disk_phi = norm_radians(atan2(Dy, Dx));
184 in_disk_rgn = floor((.999995*in_disk_phi + PI/4)/(PI/2)) + 1;
185 out_square_a = select(in_disk_rgn,
186 in_disk_r,
187 (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
188 -in_disk_r,
189 (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
190 out_square_b = select(in_disk_rgn,
191 in_disk_phi*in_disk_r/(PI/4),
192 in_disk_r,
193 (PI - in_disk_phi)*in_disk_r/(PI/4),
194 -in_disk_r);
195 out_square_x = (out_square_a + 1)/2;
196 out_square_y = (out_square_b + 1)/2;
197 ';
198 # Announce ourselves in XML output
199 print "\t<DataDefinition>\n";
200 print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
201 print "\t</DataDefinition>\n";
202
203 # Start rcontrib processes for compute each side
204 do_tree_rtcontrib(0) if ( $doback );
205 do_tree_rtcontrib(1) if ( $doforw );
206
207 } # end of sub do_tree_bsdf()
208
209 # Run rcontrib process to generate tensor tree samples
210 sub do_tree_rtcontrib {
211 my $forw = shift;
212 my $matargs = "-m $bmodnm";
213 if ( !$forw || !$doback || $tensortree==3 ) { $matargs .= " -m $fmodnm"; }
214 my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
215 "-e '$disk2sq' -bn '$ns*$ns' " .
216 "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
217 "-o $td/%s.flt $matargs $octree";
218 if ( $tensortree == 3 ) {
219 # Isotropic BSDF
220 my $ns2 = $ns / 2;
221 $cmd = "cnt $ns2 $ny $nx " .
222 "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
223 "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
224 "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
225 "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
226 "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
227 "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
228 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
229 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
230 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
231 "| $cmd";
232 } else {
233 # Anisotropic BSDF
234 # Sample area vertically to improve load balance, since
235 # shading systems usually have bilateral symmetry (L-R)
236 $cmd = "cnt $ns $ns $ny $nx " .
237 "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
238 "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
239 "-e 'r3=rand(3.17603772*recno+83.766771)' " .
240 "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
241 "-e 'in_square_x=(\$1+r1)/$ns' " .
242 "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
243 "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
244 "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
245 "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
246 "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
247 "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
248 "| $cmd";
249 }
250 # print STDERR "Starting: $cmd\n";
251 system "$cmd" || die "Failure running rcontrib";
252 ttree_out($forw);
253 } # end of do_tree_rtcontrib()
254
255 # Simplify and output tensor tree results
256 sub ttree_out {
257 my $forw = shift;
258 my $side = ("Back","Front")[$forw];
259 my $cmd;
260 # Only output one transmitted anisotropic distribution, preferring backwards
261 if ( !$forw || !$doback || $tensortree==3 ) {
262 print
263 ' <WavelengthData>
264 <LayerNumber>System</LayerNumber>
265 <Wavelength unit="Integral">Visible</Wavelength>
266 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
267 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
268 <WavelengthDataBlock>
269 ';
270 print "\t\t\t<WavelengthDataDirection>Transmission $side</WavelengthDataDirection>\n";
271 print
272 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
273 <ScatteringDataType>BTDF</ScatteringDataType>
274 <ScatteringData>
275 ';
276 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
277 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
278 if ($pctcull >= 0) {
279 $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
280 "| rttree_reduce -h -ff -t $pctcull -r $tensortree -g $ttlog2";
281 $cmd .= " -a" if ($tensortree == 3);
282 system "$cmd" || die "Failure running rttree_reduce";
283 } else {
284 $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
285 print "{\n";
286 system "$cmd" || die "Failure running rcalc";
287 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
288 print "0\n";
289 }
290 print "}\n";
291 }
292 print
293 ' </ScatteringData>
294 </WavelengthDataBlock>
295 </WavelengthData>
296 ';
297 }
298 # Output reflection
299 print
300 ' <WavelengthData>
301 <LayerNumber>System</LayerNumber>
302 <Wavelength unit="Integral">Visible</Wavelength>
303 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
304 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
305 <WavelengthDataBlock>
306 ';
307 print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
308 print
309 ' <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
310 <ScatteringDataType>BTDF</ScatteringDataType>
311 <ScatteringData>
312 ';
313 $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
314 q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
315 if ($pctcull >= 0) {
316 $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
317 "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
318 system "$cmd" || die "Failure running rttree_reduce";
319 } else {
320 $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
321 print "{\n";
322 system "$cmd" || die "Failure running rcalc";
323 for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
324 print "0\n";
325 }
326 print "}\n";
327 }
328 print
329 ' </ScatteringData>
330 </WavelengthDataBlock>
331 </WavelengthData>
332 ';
333 } # end of ttree_out()
334
335 #------------- End of do_tree_bsdf() & subroutines -------------#
336
337 #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
338 sub do_matrix_bsdf {
339 # Set up sampling of portal
340 # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
341 $tcal = '
342 DEGREE : PI/180;
343 sq(x) : x*x;
344 Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
345 Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
346 Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
347 Kmax : Kaccum(Knaz(0));
348 Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
349 Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
350 Kcol = Kbin - Kaccum(Krow-1);
351 Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
352 Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
353 sin_kpol = sin(Kpol);
354 Dx = cos(Kazi)*sin_kpol;
355 Dy = sin(Kazi)*sin_kpol;
356 Dz = sqrt(1 - sin_kpol*sin_kpol);
357 KprojOmega = PI * if(Kbin-.5,
358 (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
359 1 - sq(cos(Kpola(1)*DEGREE)));
360 ';
361 # Compute Klems bin from exiting ray direction (forward or backward)
362 $kcal = '
363 DEGREE : PI/180;
364 abs(x) : if(x, x, -x);
365 Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
366 posangle(a) : if(-a, a + 2*PI, a);
367 Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
368 kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
369 knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
370 kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
371 kfindrow(r, pol) : if(r-kpola(0)+.5, r,
372 if(pol-kpola(r), kfindrow(r+1, pol), r) );
373 kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
374 kbin2(pol,azi) = select(kfindrow(1, pol),
375 kazn(azi,360/knaz(1)),
376 kaccum(1) + kazn(azi,360/knaz(2)),
377 kaccum(2) + kazn(azi,360/knaz(3)),
378 kaccum(3) + kazn(azi,360/knaz(4)),
379 kaccum(4) + kazn(azi,360/knaz(5)),
380 kaccum(5) + kazn(azi,360/knaz(6)),
381 kaccum(6) + kazn(azi,360/knaz(7)),
382 kaccum(7) + kazn(azi,360/knaz(8)),
383 kaccum(8) + kazn(azi,360/knaz(9))
384 );
385 kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
386 ';
387 my $ndiv = 145;
388 # Compute scattering data using rcontrib
389 my @tfarr;
390 my @rfarr;
391 my @tbarr;
392 my @rbarr;
393 my $cmd;
394 my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
395 "-e '$kcal' -b kbin -bn $ndiv " .
396 "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
397 my $rccmd = "rcalc -e '$tcal' " .
398 "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
399 q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
400 if ( $doforw ) {
401 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
402 "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
403 "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
404 "-e 'zp:$dim[4]' " .
405 q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
406 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
407 "| $rtcmd";
408 system "$cmd" || die "Failure running: $cmd\n";
409 @tfarr = `$rccmd $td/$fmodnm.flt`;
410 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
411 chomp(@tfarr);
412 @rfarr = `$rccmd $td/$bmodnm.flt`;
413 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
414 chomp(@rfarr);
415 }
416 if ( $doback ) {
417 $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
418 "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
419 "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
420 "-e 'zp:$dim[5]' " .
421 q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
422 q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
423 "| $rtcmd";
424 system "$cmd" || die "Failure running: $cmd\n";
425 @tbarr = `$rccmd $td/$bmodnm.flt`;
426 die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
427 chomp(@tbarr);
428 @rbarr = `$rccmd $td/$fmodnm.flt`;
429 die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
430 chomp(@rbarr);
431 }
432 # Output angle basis
433 print
434 ' <DataDefinition>
435 <IncidentDataStructure>Columns</IncidentDataStructure>
436 <AngleBasis>
437 <AngleBasisName>LBNL/Klems Full</AngleBasisName>
438 <AngleBasisBlock>
439 <Theta>0</Theta>
440 <nPhis>1</nPhis>
441 <ThetaBounds>
442 <LowerTheta>0</LowerTheta>
443 <UpperTheta>5</UpperTheta>
444 </ThetaBounds>
445 </AngleBasisBlock>
446 <AngleBasisBlock>
447 <Theta>10</Theta>
448 <nPhis>8</nPhis>
449 <ThetaBounds>
450 <LowerTheta>5</LowerTheta>
451 <UpperTheta>15</UpperTheta>
452 </ThetaBounds>
453 </AngleBasisBlock>
454 <AngleBasisBlock>
455 <Theta>20</Theta>
456 <nPhis>16</nPhis>
457 <ThetaBounds>
458 <LowerTheta>15</LowerTheta>
459 <UpperTheta>25</UpperTheta>
460 </ThetaBounds>
461 </AngleBasisBlock>
462 <AngleBasisBlock>
463 <Theta>30</Theta>
464 <nPhis>20</nPhis>
465 <ThetaBounds>
466 <LowerTheta>25</LowerTheta>
467 <UpperTheta>35</UpperTheta>
468 </ThetaBounds>
469 </AngleBasisBlock>
470 <AngleBasisBlock>
471 <Theta>40</Theta>
472 <nPhis>24</nPhis>
473 <ThetaBounds>
474 <LowerTheta>35</LowerTheta>
475 <UpperTheta>45</UpperTheta>
476 </ThetaBounds>
477 </AngleBasisBlock>
478 <AngleBasisBlock>
479 <Theta>50</Theta>
480 <nPhis>24</nPhis>
481 <ThetaBounds>
482 <LowerTheta>45</LowerTheta>
483 <UpperTheta>55</UpperTheta>
484 </ThetaBounds>
485 </AngleBasisBlock>
486 <AngleBasisBlock>
487 <Theta>60</Theta>
488 <nPhis>24</nPhis>
489 <ThetaBounds>
490 <LowerTheta>55</LowerTheta>
491 <UpperTheta>65</UpperTheta>
492 </ThetaBounds>
493 </AngleBasisBlock>
494 <AngleBasisBlock>
495 <Theta>70</Theta>
496 <nPhis>16</nPhis>
497 <ThetaBounds>
498 <LowerTheta>65</LowerTheta>
499 <UpperTheta>75</UpperTheta>
500 </ThetaBounds>
501 </AngleBasisBlock>
502 <AngleBasisBlock>
503 <Theta>82.5</Theta>
504 <nPhis>12</nPhis>
505 <ThetaBounds>
506 <LowerTheta>75</LowerTheta>
507 <UpperTheta>90</UpperTheta>
508 </ThetaBounds>
509 </AngleBasisBlock>
510 </AngleBasis>
511 </DataDefinition>
512 ';
513 if ( $doforw ) {
514 print
515 ' <WavelengthData>
516 <LayerNumber>System</LayerNumber>
517 <Wavelength unit="Integral">Visible</Wavelength>
518 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
519 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
520 <WavelengthDataBlock>
521 <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
522 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
523 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
524 <ScatteringDataType>BTDF</ScatteringDataType>
525 <ScatteringData>
526 ';
527 # Output front transmission (transposed order)
528 for (my $od = 0; $od < $ndiv; $od++) {
529 for (my $id = 0; $id < $ndiv; $id++) {
530 print $tfarr[$ndiv*$id + $od], ",\n";
531 }
532 print "\n";
533 }
534 print
535 ' </ScatteringData>
536 </WavelengthDataBlock>
537 </WavelengthData>
538 <WavelengthData>
539 <LayerNumber>System</LayerNumber>
540 <Wavelength unit="Integral">Visible</Wavelength>
541 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
542 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
543 <WavelengthDataBlock>
544 <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
545 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
546 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
547 <ScatteringDataType>BTDF</ScatteringDataType>
548 <ScatteringData>
549 ';
550 # Output front reflection (transposed order)
551 for (my $od = 0; $od < $ndiv; $od++) {
552 for (my $id = 0; $id < $ndiv; $id++) {
553 print $rfarr[$ndiv*$id + $od], ",\n";
554 }
555 print "\n";
556 }
557 print
558 ' </ScatteringData>
559 </WavelengthDataBlock>
560 </WavelengthData>
561 ';
562 }
563 if ( $doback ) {
564 print
565 ' <WavelengthData>
566 <LayerNumber>System</LayerNumber>
567 <Wavelength unit="Integral">Visible</Wavelength>
568 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
569 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
570 <WavelengthDataBlock>
571 <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
572 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
573 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
574 <ScatteringDataType>BTDF</ScatteringDataType>
575 <ScatteringData>
576 ';
577 # Output back transmission (transposed order)
578 for (my $od = 0; $od < $ndiv; $od++) {
579 for (my $id = 0; $id < $ndiv; $id++) {
580 print $tbarr[$ndiv*$id + $od], ",\n";
581 }
582 print "\n";
583 }
584 print
585 ' </ScatteringData>
586 </WavelengthDataBlock>
587 </WavelengthData>
588 <WavelengthData>
589 <LayerNumber>System</LayerNumber>
590 <Wavelength unit="Integral">Visible</Wavelength>
591 <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
592 <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
593 <WavelengthDataBlock>
594 <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
595 <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
596 <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
597 <ScatteringDataType>BTDF</ScatteringDataType>
598 <ScatteringData>
599 ';
600 # Output back reflection (transposed order)
601 for (my $od = 0; $od < $ndiv; $od++) {
602 for (my $id = 0; $id < $ndiv; $id++) {
603 print $rbarr[$ndiv*$id + $od], ",\n";
604 }
605 print "\n";
606 }
607 print
608 ' </ScatteringData>
609 </WavelengthDataBlock>
610 </WavelengthData>
611 ';
612 }
613 }
614 #------------- End of do_matrix_bsdf() --------------#